<?php
require_once('UtilisateurDAO.php');
require_once('Article.php');
require_once('Utilisateur.php');
require_once('Codes.php');

class ArticleDAO {

  /**
   * Liste les articles. Renvoie un ensemble d'objets Titres.
   * $prive : si privé est vrai, alors tous les articles seront listés. Sinon seuls les articles publics le seront.
   */
  function listeTitres($prive) {
    global $DB_INFO;
    $db= null;
    $db= $DB_INFO->creerConnexion();
    if ($prive) {
      $st= $db->query("select id_article, titre from article");
    } else {
      $st= $db->query("select id_article, titre from article where prive = 0");
    }
    $resultat= array();
    while ($t= $st->fetchObject('Titre')) {
      $resultat[]= $t;
    }
    return $resultat;
  }

  function lireArticle($id) {
    global $DB_INFO;
    $db= null;
    $db= $DB_INFO->creerConnexion();
    $st = $db->prepare("SELECT * FROM article WHERE id_article= :id");
    $st->bindParam(":id", $id);
    $st->execute();
    $resultat= $st->fetchObject('Article');
    $auteurDAO= new UtilisateurDAO();
    $resultat->auteur= $auteurDAO->lireUtilisateurParId($resultat->id_auteur);
    if ($resultat) {
      return $resultat;
    } else {
      return false;
    }
    // La connexion est automatiquement fermée car $db est locale.
  }

  // Crée un article
  function creer($article) {
    global $DB_INFO;
    $db= null;
    $db= $DB_INFO->creerConnexion();
    $st = $db->prepare("INSERT INTO article (titre, texte, creation, prive, id_auteur) VALUES (?,?,NOW(),?,?)");
    $st->bindValue(1, $article->titre);
    $st->bindValue(2, $article->texte);
    $st->bindValue(3, $article->prive);
    $st->bindValue(4, $article->auteur->id_auteur);
    
    $st->execute();
    $article->id_article= $db->lastInsertId();
    // fixer aussi la date de l'article... à voir.
  }
}

?>